=== debian/changelog ===
ikos (3.2-3) unstable; urgency=medium

  * Add missing Build-Depends (Closes: #1064351)

 -- Scott Talbert <swt@techie.net>  Tue, 20 Feb 2024 18:53:42 -0500

ikos (3.2-2) unstable; urgency=medium

  * Mark ikos as auto-buildable

 -- Scott Talbert <swt@techie.net>  Thu, 08 Feb 2024 23:11:01 -0500

ikos (3.2-1) unstable; urgency=medium

  * Initial release.

 -- Scott Talbert <swt@techie.net>  Tue, 16 Jan 2024 22:21:26 -0500
