=== debian/control ===
Source: ikos
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Scott Talbert <swt@techie.net>
Section: non-free/devel
Priority: optional
Build-Depends:
 clang-14,
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-test-dev,
 libboost-thread-dev,
 libgmp-dev,
 libsqlite3-dev,
 libtbb-dev,
 libz-dev,
 llvm-14-dev,
 python3,
 python3-setuptools,
Standards-Version: 4.6.2
Homepage: https://github.com/NASA-SW-VnV/ikos
Vcs-Git: https://salsa.debian.org/python-team/packages/ikos.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/ikos
Rules-Requires-Root: no
XS-Autobuild: yes

Package: ikos
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 clang-14,
Description: Static analyzer for C/C++
 IKOS (Inference Kernel for Open Static Analyzers) is a static analyzer for
 C/C++ based on the theory of Abstract Interpretation.
 .
 IKOS started as a C++ library designed to facilitate the development of sound
 static analyzers based on Abstract Interpretation. Specialization of a static
 analyzer for an application or family of applications is critical for
 achieving both precision and scalability. Developing such an analyzer is
 arduous and requires significant expertise in Abstract Interpretation.
 .
 IKOS provides a generic and efficient implementation of state-of-the-art
 Abstract Interpretation data structures and algorithms, such as control-flow
 graphs, fixpoint iterators, numerical abstract domains, etc. IKOS is
 independent of a particular programming language.
 .
 IKOS also provides a C and C++ static analyzer based on LLVM. It implements
 scalable analyses for detecting and proving the absence of runtime errors in
 C and C++ programs.
 .
 This package provides the static analyzer binaries.

Package: libikos
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Static analyzer for C/C++ - static libraries
 IKOS (Inference Kernel for Open Static Analyzers) is a static analyzer for
 C/C++ based on the theory of Abstract Interpretation.
 .
 IKOS started as a C++ library designed to facilitate the development of sound
 static analyzers based on Abstract Interpretation. Specialization of a static
 analyzer for an application or family of applications is critical for
 achieving both precision and scalability. Developing such an analyzer is
 arduous and requires significant expertise in Abstract Interpretation.
 .
 IKOS provides a generic and efficient implementation of state-of-the-art
 Abstract Interpretation data structures and algorithms, such as control-flow
 graphs, fixpoint iterators, numerical abstract domains, etc. IKOS is
 independent of a particular programming language.
 .
 IKOS also provides a C and C++ static analyzer based on LLVM. It implements
 scalable analyses for detecting and proving the absence of runtime errors in
 C and C++ programs.
 .
 This package provides the static libraries.

Package: libikos-dev
Architecture: any
Section: non-free/libdevel
Depends:
 libikos (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Static analyzer for C/C++ - development headers
 IKOS (Inference Kernel for Open Static Analyzers) is a static analyzer for
 C/C++ based on the theory of Abstract Interpretation.
 .
 IKOS started as a C++ library designed to facilitate the development of sound
 static analyzers based on Abstract Interpretation. Specialization of a static
 analyzer for an application or family of applications is critical for
 achieving both precision and scalability. Developing such an analyzer is
 arduous and requires significant expertise in Abstract Interpretation.
 .
 IKOS provides a generic and efficient implementation of state-of-the-art
 Abstract Interpretation data structures and algorithms, such as control-flow
 graphs, fixpoint iterators, numerical abstract domains, etc. IKOS is
 independent of a particular programming language.
 .
 IKOS also provides a C and C++ static analyzer based on LLVM. It implements
 scalable analyses for detecting and proving the absence of runtime errors in
 C and C++ programs.
 .
 This package provides the development headers.
